Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -53,10 +53,10 @@
 
 static int kbdev_ctl_init(kbd_dev_t *);
-static void kbdev_ctl_set_ind(kbd_dev_t *, unsigned);
+static void kbdev_ctl_set_ind(kbd_dev_t *, unsigned int);
 
 static void kbdev_callback_conn(ipc_callid_t, ipc_call_t *, void *arg);
 
 kbd_ctl_ops_t kbdev_ctl = {
-	.parse_scancode = NULL,
+	.parse = NULL,
 	.init = kbdev_ctl_init,
 	.set_ind = kbdev_ctl_set_ind
@@ -116,5 +116,5 @@
 	sess = fd_session(EXCHANGE_SERIALIZE, fd);
 	if (sess == NULL) {
-		printf(NAME ": Failed starting session with '%s'\n", pathname);
+		printf("%s: Failed starting session with '%s'\n", NAME, pathname);
 		close(fd);
 		return -1;
@@ -123,6 +123,6 @@
 	kbdev = kbdev_new(kdev);
 	if (kbdev == NULL) {
-		printf(NAME ": Failed allocating device structure for '%s'.\n",
-		    pathname);
+		printf("%s: Failed allocating device structure for '%s'.\n",
+		    NAME, pathname);
 		return -1;
 	}
@@ -133,5 +133,5 @@
 	exch = async_exchange_begin(sess);
 	if (exch == NULL) {
-		printf(NAME ": Failed starting exchange with '%s'.\n", pathname);
+		printf("%s: Failed starting exchange with '%s'.\n", NAME, pathname);
 		kbdev_destroy(kbdev);
 		return -1;
@@ -140,6 +140,6 @@
 	rc = async_connect_to_me(exch, 0, 0, 0, kbdev_callback_conn, kbdev);
 	if (rc != EOK) {
-		printf(NAME ": Failed creating callback connection from '%s'.\n",
-		    pathname);
+		printf("%s: Failed creating callback connection from '%s'.\n",
+		    NAME, pathname);
 		async_exchange_end(exch);
 		kbdev_destroy(kbdev);
@@ -193,5 +193,5 @@
 			type = IPC_GET_ARG1(call);
 			key = IPC_GET_ARG2(call);
-			kbd_push_ev(kbdev->kbd_dev, type, key);
+			kbd_push_event(kbdev->kbd_dev, type, key);
 			break;
 		default:
Index: uspace/srv/hid/input/ctl/pc.c
===================================================================
--- uspace/srv/hid/input/ctl/pc.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/ctl/pc.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -43,10 +43,10 @@
 #include <gsp.h>
 
-static void pc_ctl_parse_scancode(int);
+static void pc_ctl_parse(sysarg_t);
 static int pc_ctl_init(kbd_dev_t *);
-static void pc_ctl_set_ind(kbd_dev_t *, unsigned);
+static void pc_ctl_set_ind(kbd_dev_t *, unsigned int);
 
 kbd_ctl_ops_t pc_ctl = {
-	.parse_scancode = pc_ctl_parse_scancode,
+	.parse = pc_ctl_parse,
 	.init = pc_ctl_init,
 	.set_ind = pc_ctl_set_ind
@@ -215,5 +215,5 @@
 }
 
-static void pc_ctl_parse_scancode(int scancode)
+static void pc_ctl_parse(sysarg_t scancode)
 {
 	kbd_event_type_t type;
@@ -257,10 +257,10 @@
 	}
 
-	if ((scancode < 0) || ((size_t) scancode >= map_length))
+	if ((size_t) scancode >= map_length)
 		return;
 
 	key = map[scancode];
 	if (key != 0)
-		kbd_push_ev(kbd_dev, type, key);
+		kbd_push_event(kbd_dev, type, key);
 }
 
Index: uspace/srv/hid/input/ctl/stty.c
===================================================================
--- uspace/srv/hid/input/ctl/stty.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/ctl/stty.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -33,5 +33,5 @@
 /**
  * @file
- * @brief	Serial TTY-like keyboard controller driver.
+ * @brief Serial TTY-like keyboard controller driver.
  */
 
@@ -43,10 +43,10 @@
 #include <stroke.h>
 
-static void stty_ctl_parse_scancode(int);
+static void stty_ctl_parse(sysarg_t);
 static int stty_ctl_init(kbd_dev_t *);
-static void stty_ctl_set_ind(kbd_dev_t *, unsigned);
+static void stty_ctl_set_ind(kbd_dev_t *, unsigned int);
 
 kbd_ctl_ops_t stty_ctl = {
-	.parse_scancode = stty_ctl_parse_scancode,
+	.parse = stty_ctl_parse,
 	.init = stty_ctl_init,
 	.set_ind = stty_ctl_set_ind
@@ -228,5 +228,5 @@
 }
 
-static void stty_ctl_parse_scancode(int scancode)
+static void stty_ctl_parse(sysarg_t scancode)
 {
 	unsigned mods, key;
Index: uspace/srv/hid/input/ctl/sun.c
===================================================================
--- uspace/srv/hid/input/ctl/sun.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/ctl/sun.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -34,5 +34,5 @@
 /**
  * @file
- * @brief	Sun keyboard controller driver.
+ * @brief Sun keyboard controller driver.
  */
 
@@ -43,10 +43,10 @@
 #include <kbd_port.h>
 
-static void sun_ctl_parse_scancode(int);
+static void sun_ctl_parse(sysarg_t);
 static int sun_ctl_init(kbd_dev_t *);
-static void sun_ctl_set_ind(kbd_dev_t *, unsigned);
+static void sun_ctl_set_ind(kbd_dev_t *, unsigned int);
 
 kbd_ctl_ops_t sun_ctl = {
-	.parse_scancode = sun_ctl_parse_scancode,
+	.parse = sun_ctl_parse,
 	.init = sun_ctl_init,
 	.set_ind = sun_ctl_set_ind
@@ -66,10 +66,10 @@
 }
 
-static void sun_ctl_parse_scancode(int scancode)
+static void sun_ctl_parse(sysarg_t scancode)
 {
 	kbd_event_type_t type;
 	unsigned int key;
 
-	if (scancode < 0 || scancode >= 0x100)
+	if (scancode >= 0x100)
 		return;
 
@@ -86,5 +86,5 @@
 	key = scanmap_simple[scancode];
 	if (key != 0)
-		kbd_push_ev(kbd_dev, type, key);
+		kbd_push_event(kbd_dev, type, key);
 }
 
Index: uspace/srv/hid/input/generic/input.c
===================================================================
--- uspace/srv/hid/input/generic/input.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/generic/input.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -58,4 +58,5 @@
 #include <kbd_port.h>
 #include <kbd_ctl.h>
+#include <mouse_proto.h>
 #include <layout.h>
 #include <mouse.h>
@@ -65,23 +66,7 @@
 
 /* In microseconds */
-#define DISCOVERY_POLL_INTERVAL		(10*1000*1000)
-
-static void kbd_devs_yield(void);
-static void kbd_devs_reclaim(void);
-
-static void input_event_key(int, unsigned int, unsigned, wchar_t);
-
-int client_phone = -1;
-
-/** List of keyboard devices */
-static list_t kbd_devs;
-
-/** List of mouse devices */
-list_t mouse_devs;
-
-bool irc_service = false;
-int irc_phone = -1;
-
-#define NUM_LAYOUTS 3
+#define DISCOVERY_POLL_INTERVAL  (10 * 1000 * 1000)
+
+#define NUM_LAYOUTS  3
 
 static layout_ops_t *layout[NUM_LAYOUTS] = {
@@ -91,15 +76,33 @@
 };
 
-void kbd_push_scancode(kbd_dev_t *kdev, int scancode)
-{
-/*	printf("scancode: 0x%x\n", scancode);*/
-	(*kdev->ctl_ops->parse_scancode)(scancode);
-}
-
-void kbd_push_ev(kbd_dev_t *kdev, int type, unsigned int key)
+static void kbd_devs_yield(void);
+static void kbd_devs_reclaim(void);
+
+int client_phone = -1;
+
+/** List of keyboard devices */
+static list_t kbd_devs;
+
+/** List of mouse devices */
+static list_t mouse_devs;
+
+bool irc_service = false;
+int irc_phone = -1;
+
+void kbd_push_data(kbd_dev_t *kdev, sysarg_t data)
+{
+	(*kdev->ctl_ops->parse)(data);
+}
+
+void mouse_push_data(mouse_dev_t *mdev, sysarg_t data)
+{
+	(*mdev->proto_ops->parse)(data);
+}
+
+void kbd_push_event(kbd_dev_t *kdev, int type, unsigned int key)
 {
 	kbd_event_t ev;
-	unsigned mod_mask;
-
+	unsigned int mod_mask;
+	
 	switch (key) {
 	case KC_LCTRL: mod_mask = KM_LCTRL; break;
@@ -111,5 +114,5 @@
 	default: mod_mask = 0; break;
 	}
-
+	
 	if (mod_mask != 0) {
 		if (type == KEY_PRESS)
@@ -118,5 +121,5 @@
 			kdev->mods = kdev->mods & ~mod_mask;
 	}
-
+	
 	switch (key) {
 	case KC_CAPS_LOCK: mod_mask = KM_CAPS_LOCK; break;
@@ -125,5 +128,5 @@
 	default: mod_mask = 0; break;
 	}
-
+	
 	if (mod_mask != 0) {
 		if (type == KEY_PRESS) {
@@ -135,5 +138,5 @@
 			kdev->mods = kdev->mods ^ (mod_mask & ~kdev->lock_keys);
 			kdev->lock_keys = kdev->lock_keys | mod_mask;
-
+			
 			/* Update keyboard lock indicator lights. */
 			(*kdev->ctl_ops->set_ind)(kdev, kdev->mods);
@@ -142,48 +145,37 @@
 		}
 	}
-/*
-	printf("type: %d\n", type);
-	printf("mods: 0x%x\n", mods);
-	printf("keycode: %u\n", key);
-*/
+	
 	if (type == KEY_PRESS && (kdev->mods & KM_LCTRL) &&
-		key == KC_F1) {
+	    key == KC_F1) {
 		layout_destroy(kdev->active_layout);
 		kdev->active_layout = layout_create(layout[0]);
 		return;
 	}
-
+	
 	if (type == KEY_PRESS && (kdev->mods & KM_LCTRL) &&
-		key == KC_F2) {
+	    key == KC_F2) {
 		layout_destroy(kdev->active_layout);
 		kdev->active_layout = layout_create(layout[1]);
 		return;
 	}
-
+	
 	if (type == KEY_PRESS && (kdev->mods & KM_LCTRL) &&
-		key == KC_F3) {
+	    key == KC_F3) {
 		layout_destroy(kdev->active_layout);
 		kdev->active_layout = layout_create(layout[2]);
 		return;
 	}
-
+	
 	ev.type = type;
 	ev.key = key;
 	ev.mods = kdev->mods;
-
+	
 	ev.c = layout_parse_ev(kdev->active_layout, &ev);
-	input_event_key(ev.type, ev.key, ev.mods, ev.c);
-}
-
-/** Key has been pressed or released. */
-static void input_event_key(int type, unsigned int key, unsigned mods,
-    wchar_t c)
-{
-	async_obsolete_msg_4(client_phone, INPUT_EVENT_KEY, type, key,
-	    mods, c);
+	async_obsolete_msg_4(client_phone, INPUT_EVENT_KEY, ev.type, ev.key,
+	    ev.mods, ev.c);
 }
 
 /** Mouse pointer has moved. */
-void input_event_move(int dx, int dy)
+void mouse_push_event_move(mouse_dev_t *mdev, int dx, int dy)
 {
 	async_obsolete_msg_2(client_phone, INPUT_EVENT_MOVE, dx, dy);
@@ -191,5 +183,5 @@
 
 /** Mouse button has been pressed. */
-void input_event_button(int bnum, int press)
+void mouse_push_event_button(mouse_dev_t *mdev, int bnum, int press)
 {
 	async_obsolete_msg_2(client_phone, INPUT_EVENT_BUTTON, bnum, press);
@@ -201,7 +193,7 @@
 	ipc_call_t call;
 	int retval;
-
+	
 	async_answer_0(iid, EOK);
-
+	
 	while (true) {
 		callid = async_get_call(&call);
@@ -237,26 +229,39 @@
 			retval = EINVAL;
 		}
+		
 		async_answer_0(callid, retval);
-	}	
+	}
 }
 
 static kbd_dev_t *kbd_dev_new(void)
 {
-	kbd_dev_t *kdev;
-
-	kdev = calloc(1, sizeof(kbd_dev_t));
+	kbd_dev_t *kdev = calloc(1, sizeof(kbd_dev_t));
 	if (kdev == NULL) {
-		printf(NAME ": Error allocating keyboard device. "
-		    "Out of memory.\n");
+		printf("%s: Error allocating keyboard device. "
+		    "Out of memory.\n", NAME);
 		return NULL;
 	}
-
+	
 	link_initialize(&kdev->kbd_devs);
-
+	
 	kdev->mods = KM_NUM_LOCK;
 	kdev->lock_keys = 0;
 	kdev->active_layout = layout_create(layout[0]);
-
+	
 	return kdev;
+}
+
+static mouse_dev_t *mouse_dev_new(void)
+{
+	mouse_dev_t *mdev = calloc(1, sizeof(mouse_dev_t));
+	if (mdev == NULL) {
+		printf("%s: Error allocating keyboard device. "
+		    "Out of memory.\n", NAME);
+		return NULL;
+	}
+	
+	link_initialize(&mdev->mouse_devs);
+	
+	return mdev;
 }
 
@@ -264,18 +269,16 @@
 static void kbd_add_dev(kbd_port_ops_t *port, kbd_ctl_ops_t *ctl)
 {
-	kbd_dev_t *kdev;
-
-	kdev = kbd_dev_new();
+	kbd_dev_t *kdev = kbd_dev_new();
 	if (kdev == NULL)
 		return;
-
+	
 	kdev->port_ops = port;
 	kdev->ctl_ops = ctl;
 	kdev->dev_path = NULL;
-
+	
 	/* Initialize port driver. */
 	if ((*kdev->port_ops->init)(kdev) != 0)
 		goto fail;
-
+	
 	/* Initialize controller driver. */
 	if ((*kdev->ctl_ops->init)(kdev) != 0) {
@@ -283,36 +286,93 @@
 		goto fail;
 	}
-
+	
 	list_append(&kdev->kbd_devs, &kbd_devs);
 	return;
+	
 fail:
 	free(kdev);
 }
 
+/** Add new legacy mouse device. */
+static void mouse_add_dev(mouse_port_ops_t *port, mouse_proto_ops_t *proto)
+{
+	mouse_dev_t *mdev = mouse_dev_new();
+	if (mdev == NULL)
+		return;
+	
+	mdev->port_ops = port;
+	mdev->proto_ops = proto;
+	mdev->dev_path = NULL;
+	
+	/* Initialize port driver. */
+	if ((*mdev->port_ops->init)(mdev) != 0)
+		goto fail;
+	
+	/* Initialize protocol driver. */
+	if ((*mdev->proto_ops->init)(mdev) != 0) {
+		/* XXX Uninit port */
+		goto fail;
+	}
+	
+	list_append(&mdev->mouse_devs, &mouse_devs);
+	return;
+	
+fail:
+	free(mdev);
+}
+
 /** Add new kbdev device.
  *
- * @param dev_path	Filesystem path to the device (/dev/class/...)
+ * @param dev_path Filesystem path to the device (/dev/class/...)
+ *
  */
 static int kbd_add_kbdev(const char *dev_path)
 {
-	kbd_dev_t *kdev;
-
-	kdev = kbd_dev_new();
+	kbd_dev_t *kdev = kbd_dev_new();
 	if (kdev == NULL)
 		return -1;
-
+	
 	kdev->dev_path = dev_path;
 	kdev->port_ops = NULL;
 	kdev->ctl_ops = &kbdev_ctl;
-
+	
 	/* Initialize controller driver. */
 	if ((*kdev->ctl_ops->init)(kdev) != 0) {
 		goto fail;
 	}
-
+	
 	list_append(&kdev->kbd_devs, &kbd_devs);
 	return EOK;
+	
 fail:
 	free(kdev);
+	return -1;
+}
+
+/** Add new mousedev device.
+ *
+ * @param dev_path Filesystem path to the device (/dev/class/...)
+ *
+ */
+static int mouse_add_mousedev(const char *dev_path)
+{
+	mouse_dev_t *mdev = mouse_dev_new();
+	if (mdev == NULL)
+		return -1;
+	
+	mdev->dev_path = dev_path;
+	mdev->port_ops = NULL;
+	mdev->proto_ops = &mousedev_proto;
+	
+	/* Initialize controller driver. */
+	if ((*mdev->proto_ops->init)(mdev) != 0) {
+		goto fail;
+	}
+	
+	list_append(&mdev->mouse_devs, &mouse_devs);
+	return EOK;
+	
+fail:
+	free(mdev);
 	return -1;
 }
@@ -364,13 +424,32 @@
 	kbd_add_dev(&niagara_port, &stty_ctl);
 #endif
-#if defined(UARCH_sparc64) && defined(MACHINE_serengeti)
-	kbd_add_dev(&sgcn_port, &stty_ctl);
-#endif
 #if defined(UARCH_sparc64) && defined(MACHINE_generic)
-	kbd_add_dev(&z8530_port, &sun_ctl);
 	kbd_add_dev(&ns16550_port, &sun_ctl);
 #endif
 	/* Silence warning on abs32le about kbd_add_dev() being unused */
 	(void) kbd_add_dev;
+}
+
+/** Add legacy drivers/devices. */
+static void mouse_add_legacy_devs(void)
+{
+	/*
+	 * Need to add these drivers based on config unless we can probe
+	 * them automatically.
+	 */
+#if defined(UARCH_amd64)
+	mouse_add_dev(&chardev_mouse_port, &ps2_proto);
+#endif
+#if defined(UARCH_ia32)
+	mouse_add_dev(&chardev_mouse_port, &ps2_proto);
+#endif
+#if defined(MACHINE_i460GX)
+	mouse_add_dev(&chardev_mouse_port, &ps2_proto);
+#endif
+#if defined(UARCH_ppc32)
+	mouse_add_dev(&adb_mouse_port, &adb_proto);
+#endif
+	/* Silence warning on abs32le about mouse_add_dev() being unused */
+	(void) mouse_add_dev;
 }
 
@@ -381,5 +460,5 @@
 		kbd_dev_t *kdev = list_get_instance(kdev_link, kbd_dev_t,
 		    kbd_devs);
-
+		
 		/* Yield port */
 		if (kdev->port_ops != NULL)
@@ -394,5 +473,5 @@
 		kbd_dev_t *kdev = list_get_instance(kdev_link, kbd_dev_t,
 		    kbd_devs);
-
+		
 		/* Reclaim port */
 		if (kdev->port_ops != NULL)
@@ -405,5 +484,6 @@
  * Looks under /dev/class/keyboard and /dev/class/mouse.
  *
- * @param arg	Ignored
+ * @param arg Ignored
+ *
  */
 static int dev_discovery_fibril(void *arg)
@@ -413,8 +493,8 @@
 	size_t mouse_id = 1;
 	int rc;
-
+	
 	while (true) {
 		async_usleep(DISCOVERY_POLL_INTERVAL);
-
+		
 		/*
 		 * Check for new keyboard device
@@ -423,15 +503,15 @@
 		if (rc < 0)
 			continue;
-
+		
 		if (kbd_add_kbdev(dev_path) == EOK) {
-			printf(NAME ": Connected keyboard device '%s'\n",
-			    dev_path);
-
+			printf("%s: Connected keyboard device '%s'\n",
+			    NAME, dev_path);
+			
 			/* XXX Handle device removal */
 			++kbd_id;
 		}
-
+		
 		free(dev_path);
-
+		
 		/*
 		 * Check for new mouse device
@@ -440,16 +520,16 @@
 		if (rc < 0)
 			continue;
-
-		if (mouse_add_dev(dev_path) == EOK) {
-			printf(NAME ": Connected mouse device '%s'\n",
-			    dev_path);
-
+		
+		if (mouse_add_mousedev(dev_path) == EOK) {
+			printf("%s: Connected mouse device '%s'\n",
+			    NAME, dev_path);
+			
 			/* XXX Handle device removal */
 			++mouse_id;
 		}
-
+		
 		free(dev_path);
 	}
-
+	
 	return EOK;
 }
@@ -458,12 +538,11 @@
 static void input_start_dev_discovery(void)
 {
-	fid_t fid;
-
-	fid = fibril_create(dev_discovery_fibril, NULL);
+	fid_t fid = fibril_create(dev_discovery_fibril, NULL);
 	if (!fid) {
-		printf(NAME ": Failed to create device discovery fibril.\n");
+		printf("%s: Failed to create device discovery fibril.\n",
+		    NAME);
 		return;
 	}
-
+	
 	fibril_add_ready(fid);
 }
@@ -473,5 +552,4 @@
 	printf("%s: HelenOS input service\n", NAME);
 	
-	sysarg_t fhc;
 	sysarg_t obio;
 	
@@ -479,6 +557,5 @@
 	list_initialize(&mouse_devs);
 	
-	if (((sysinfo_get_value("kbd.cir.fhc", &fhc) == EOK) && (fhc))
-	    || ((sysinfo_get_value("kbd.cir.obio", &obio) == EOK) && (obio)))
+	if ((sysinfo_get_value("kbd.cir.obio", &obio) == EOK) && (obio))
 		irc_service = true;
 	
@@ -490,7 +567,7 @@
 	/* Add legacy keyboard devices. */
 	kbd_add_legacy_devs();
-
-	/* Add legacy (devmap-style) mouse device. */
-	(void) mouse_add_dev("/dev/hid_in/mouse");
+	
+	/* Add legacy mouse devices. */
+	mouse_add_legacy_devs();
 	
 	/* Register driver */
@@ -509,11 +586,11 @@
 		return -1;
 	}
-
+	
 	/* Start looking for new input devices */
 	input_start_dev_discovery();
-
-	printf(NAME ": Accepting connections\n");
+	
+	printf("%s: Accepting connections\n", NAME);
 	async_manager();
-
+	
 	/* Not reached. */
 	return 0;
Index: uspace/srv/hid/input/generic/layout.c
===================================================================
--- uspace/srv/hid/input/generic/layout.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/generic/layout.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -48,5 +48,5 @@
 	layout = calloc(1, sizeof(layout_t));
 	if (layout == NULL) {
-		printf(NAME ": Out of memory.\n");
+		printf("%s: Out of memory.\n", NAME);
 		return NULL;
 	}
Index: uspace/srv/hid/input/generic/stroke.c
===================================================================
--- uspace/srv/hid/input/generic/stroke.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/generic/stroke.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -60,5 +60,5 @@
 	while (mods_keys[i][0] != 0) {
 		if (mod & mods_keys[i][0]) {
-			kbd_push_ev(kdev, KEY_PRESS, mods_keys[i][1]);
+			kbd_push_event(kdev, KEY_PRESS, mods_keys[i][1]);
 		}
 		++i;
@@ -67,6 +67,6 @@
 	/* Simulate key press and release. */
 	if (key != 0) {
-		kbd_push_ev(kdev, KEY_PRESS, key);
-		kbd_push_ev(kdev, KEY_RELEASE, key);
+		kbd_push_event(kdev, KEY_PRESS, key);
+		kbd_push_event(kdev, KEY_RELEASE, key);
 	}
 
@@ -75,5 +75,5 @@
 	while (mods_keys[i][0] != 0) {
 		if (mod & mods_keys[i][0]) {
-			kbd_push_ev(kdev, KEY_RELEASE, mods_keys[i][1]);
+			kbd_push_event(kdev, KEY_RELEASE, mods_keys[i][1]);
 		}
 		++i;
Index: uspace/srv/hid/input/include/input.h
===================================================================
--- uspace/srv/hid/input/include/input.h	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/include/input.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -42,13 +42,8 @@
 
 #define NAME       "input"
-#define NAMESPACE  "hid_in"
+#define NAMESPACE  "hid"
 
 extern bool irc_service;
 extern int irc_phone;
-
-extern list_t mouse_devs;
-
-void input_event_move(int, int);
-void input_event_button(int bnum, int press);
 
 #endif
Index: uspace/srv/hid/input/include/kbd.h
===================================================================
--- uspace/srv/hid/input/include/kbd.h	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/include/kbd.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -71,6 +71,6 @@
 } kbd_dev_t;
 
-extern void kbd_push_scancode(kbd_dev_t *, int);
-extern void kbd_push_ev(kbd_dev_t *, int, unsigned int);
+extern void kbd_push_data(kbd_dev_t *, sysarg_t);
+extern void kbd_push_event(kbd_dev_t *, int, unsigned int);
 
 #endif
Index: uspace/srv/hid/input/include/kbd_ctl.h
===================================================================
--- uspace/srv/hid/input/include/kbd_ctl.h	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/include/kbd_ctl.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -28,6 +28,6 @@
 
 /** @addtogroup inputgen generic
- * @brief	Keyboard controller driver interface.
- * @ingroup  input
+ * @brief Keyboard controller driver interface.
+ * @ingroup input
  * @{
  */
@@ -43,7 +43,7 @@
 
 typedef struct kbd_ctl_ops {
-	void (*parse_scancode)(int);
+	void (*parse)(sysarg_t);
 	int (*init)(struct kbd_dev *);
-	void (*set_ind)(struct kbd_dev *, unsigned);
+	void (*set_ind)(struct kbd_dev *, unsigned int);
 } kbd_ctl_ops_t;
 
@@ -59,4 +59,3 @@
 /**
  * @}
- */ 
-
+ */
Index: uspace/srv/hid/input/include/kbd_port.h
===================================================================
--- uspace/srv/hid/input/include/kbd_port.h	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/include/kbd_port.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -28,6 +28,6 @@
 
 /** @addtogroup inputgen generic
- * @brief	Keyboard port driver interface.
- * @ingroup  input
+ * @brief Keyboard port driver interface.
+ * @ingroup input
  * @{
  */
@@ -51,5 +51,4 @@
 extern kbd_port_ops_t adb_port;
 extern kbd_port_ops_t chardev_port;
-extern kbd_port_ops_t dummy_port;
 extern kbd_port_ops_t gxemul_port;
 extern kbd_port_ops_t msim_port;
@@ -57,7 +56,5 @@
 extern kbd_port_ops_t ns16550_port;
 extern kbd_port_ops_t pl050_port;
-extern kbd_port_ops_t sgcn_port;
 extern kbd_port_ops_t ski_port;
-extern kbd_port_ops_t z8530_port;
 
 #endif
@@ -65,4 +62,3 @@
 /**
  * @}
- */ 
-
+ */
Index: uspace/srv/hid/input/include/mouse.h
===================================================================
--- uspace/srv/hid/input/include/mouse.h	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/include/mouse.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -40,13 +40,24 @@
 #include <adt/list.h>
 
+struct mouse_port_ops;
+struct mouse_proto_ops;
+
 typedef struct mouse_dev {
 	/** Link to mouse_devs list */
 	link_t mouse_devs;
-
-	/** Path to the device */
+	
+	/** Path to the device (only for mouseev devices) */
 	const char *dev_path;
+	
+	/** Port ops */
+	struct mouse_port_ops *port_ops;
+	
+	/** Protocol ops */
+	struct mouse_proto_ops *proto_ops;
 } mouse_dev_t;
 
-int mouse_add_dev(const char *dev_path);
+extern void mouse_push_data(mouse_dev_t *, sysarg_t);
+extern void mouse_push_event_move(mouse_dev_t *, int, int);
+extern void mouse_push_event_button(mouse_dev_t *, int, int);
 
 #endif
Index: uspace/srv/hid/input/include/mouse_port.h
===================================================================
--- uspace/srv/hid/input/include/mouse_port.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
+++ uspace/srv/hid/input/include/mouse_port.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup inputgen generic
+ * @brief Mouse port driver interface.
+ * @ingroup input
+ * @{
+ */
+/** @file
+ */
+
+#ifndef MOUSE_PORT_H_
+#define MOUSE_PORT_H_
+
+#include <sys/types.h>
+
+struct mouse_dev;
+
+typedef struct mouse_port_ops {
+	int (*init)(struct mouse_dev *);
+	void (*yield)(void);
+	void (*reclaim)(void);
+	void (*write)(uint8_t);
+} mouse_port_ops_t;
+
+extern mouse_port_ops_t adb_mouse_port;
+extern mouse_port_ops_t chardev_mouse_port;
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/srv/hid/input/include/mouse_proto.h
===================================================================
--- uspace/srv/hid/input/include/mouse_proto.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
+++ uspace/srv/hid/input/include/mouse_proto.h	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup inputgen generic
+ * @brief Mouse protocol driver interface.
+ * @ingroup input
+ * @{
+ */
+/** @file
+ */
+
+#ifndef MOUSE_PROTO_H_
+#define MOUSE_PROTO_H_
+
+#include <mouse_port.h>
+
+struct mouse_dev;
+
+typedef struct mouse_proto_ops {
+	void (*parse)(sysarg_t);
+	int (*init)(struct mouse_dev *);
+} mouse_proto_ops_t;
+
+extern mouse_proto_ops_t adb_proto;
+extern mouse_proto_ops_t ps2_proto;
+extern mouse_proto_ops_t mousedev_proto;
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/srv/hid/input/layout/cz.c
===================================================================
--- uspace/srv/hid/input/layout/cz.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/layout/cz.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -391,5 +391,5 @@
 	cz_state = malloc(sizeof(layout_cz_t));
 	if (cz_state == NULL) {
-		printf(NAME ": Out of memory.\n");
+		printf("%s: Out of memory.\n", NAME);
 		return ENOMEM;
 	}
Index: uspace/srv/hid/input/port/adb.c
===================================================================
--- uspace/srv/hid/input/port/adb.c	(revision c427578bcf728e54b3faa5b793644ab0bd01f2b0)
+++ uspace/srv/hid/input/port/adb.c	(revision 9e347505f2957b1ffd7c974e4803f481117736a3)
@@ -37,5 +37,4 @@
 #include <ipc/adb.h>
 #include <async.h>
-#include <async_obsolete.h>
 #include <input.h>
 #include <kbd_port.h>
@@ -45,5 +44,4 @@
 #include <errno.h>
 #include <devmap.h>
-#include <devmap_obsolete.h>
 
 static void kbd_port_events(ipc_callid_t iid, ipc_call_t *icall, void *arg);
@@ -63,5 +61,5 @@
 
 static kbd_dev_t *kbd_dev;
-static int dev_phone;
+static async_sess_t *dev_sess;
 
 static int adb_port_init(kbd_dev_t *kdev)
@@ -69,22 +67,32 @@
 	const char *dev = "adb/kbd";
 	devmap_handle_t handle;
-
+	async_exch_t *exch;
+	int rc;
+	
 	kbd_dev = kdev;
 	
-	int rc = devmap_device_get_handle(dev, &handle, 0);
-	if (rc == EOK) {
-		dev_phone = devmap_obsolete_device_connect(handle, 0);
-		if (dev_phone < 0) {
-			printf("%s: Failed to connect to device\n", NAME);
-			return dev_phone;
-		}
-	} else
+	rc = devmap_device_get_handle(dev, &handle, 0);
+	if (rc != EOK)
 		return rc;
 	
+	dev_sess = devmap_device_connect(EXCHANGE_ATOMIC, handle, 0);
+	if (dev_sess == NULL) {
+		printf("%s: Failed to connect to device\n", NAME);
+		return ENOENT;
+	}
+	
+	exch = async_exchange_begin(dev_sess);
+	if (exch == NULL) {
+		printf("%s: Failed starting exchange with device\n", NAME);
+		async_hangup(dev_sess);
+		return ENOMEM;
+	}
+	
 	/* NB: The callback connection is slotted for removal */
-	rc = async_obsolete_connect_to_me(dev_phone, 0, 0, 0, kbd_port_events,
-	    NULL);
+	rc = async_connect_to_me(exch, 0, 0, 0, kbd_port_events, NULL);
+	async_exchange_end(exch);
 	if (rc != EOK) {
-		printf(NAME ": Failed to create callback from device\n");
+		printf("%s: Failed to create callback from device\n", NAME);
+		async_hangup(dev_sess);
 		return rc;
 	}
@@ -134,13 +142,12 @@
 static void adb_kbd_reg0_data(uint16_t data)
 {
-	uint8_t b0, b1;
-
-	b0 = (data >> 8) & 0xff;
-	b1 = data & 0xff;
-
+	uint8_t b0 = (data >> 8) & 0xff;
+	uint8_t b1 = data & 0xff;
+	
 	if (b0 != 0xff)
-		kbd_push_scancode(kbd_dev, b0);
+		kbd_push_data(kbd_dev, b0);
+	
 	if (b1 != 0xff)
-		kbd_push_scancode(kbd_dev, b1);
+		kbd_push_data(kbd_dev, b1);
 }
 
